package LenkkiVihko;

import java.util.Arrays;

/**
 * @author Ossian
 * @version 13.3.2025
 *
 */
public class Asuinpaikat {
    private Asuinpaikka[] apt = new Asuinpaikka[10]; //asuinpaikat
    private int asuinpaikkoja = 0;

    /**
     * @param ap asuinpaikka
     * @return olemassa olevan tai luodun asuinpaikan ID:n
     */
    public int getApID(String ap) {
       
        for (int i = 0; i < asuinpaikkoja; i++) {
            if(ap.equals(apt[i].getNimi())) return apt[i].getID();  
        }
        
        return -1;
    }
    
    /**
     * @param apID asuinpaikan id
     * @return asuinpaikan nimen ja ilmoituksen, jos id:llä ei löydy asuinpaikkaa.
     */
    public String getAsuinpaikka(int apID) {
        if (apt[apID - 1].getID() == apID) return apt[apID - 1].getNimi();  // kokeillaan ilmeisin asuinpaikan sijainti taulukossa
        for (int i = 0; i < apt.length; i++) {
            if (apt[i].getID() == apID) return apt[i].getNimi();
        }
        return "ei löytynyt asuinpaikkaa";
    }
    
    /**
     * tämä metodi luo uuden asuinpaikan ja palauttaa sen id:n
     * @param ap asuinpaikka
     * @return asuinpaika id:n
     */
    public int luoAsuinpaikka(String ap) {
        int ID = ++asuinpaikkoja;
        if (asuinpaikkoja == apt.length) apt = Arrays.copyOf(apt, apt.length + 10);
        apt[asuinpaikkoja - 1] = new Asuinpaikka(ID, ap);
        return ID;
    }

    
}
