package LenkkiVihko;

import java.io.OutputStream;
import java.io.PrintStream;

/**
 * @author oapaaso
 * @version 4.3.2025
 *
 */
public class Jasen {
    
    private int jasenID;
    private String nimi = "";
    private int syntymavuosi = 0;
    private int asuinpaikkaID = 0;


    int seuraavajasenID = 1;
    
    /**
     * konstruktori kolmella parametrillä
     * @param apID asuinpaikkID
     * @param nimi jäsenen nimi
     * @param sv syntymävuosi
     */
    public Jasen(String nimi, int sv, int apID) {
        this.nimi = nimi;
        this.syntymavuosi = sv;
        this.asuinpaikkaID = apID;
        this.jasenID = seuraavajasenID;
        seuraavajasenID ++;
    }
    
    /**
     * konstruktori ilman parametrejä
     */
    public Jasen() {
        
    }
    
    
    /**
     * @return jäsenen nimi
     * @example
     * <pre name="test">
     *   Jasen aku = new Jasen();
     *   aku.vastaaAkuAnkka();
     *   aku.getNimi() =R= "Aku Ankka.*";
     * </pre>
     */
    public String getNimi() {
        return nimi;
    }
    
    
    /**
     * @return palauttaa asuinpaikka id:n
     */
    public int getApID() {
        return asuinpaikkaID;
    }
    
    /**
     * Apumetodi, jolla saadaan täytettyä testiarvot jäsenelle.
     */
    public void vastaaAkuAnkka() {
        nimi = "Aku Ankka";
        syntymavuosi = 1960;

    }
    
    /**
     * @return  jäsenen syntymävuoden
     */
    public int getSv() {
        return syntymavuosi;
    }
    
    /**
     * @return jasenen id:n
     */
    public int getJasenID() {
        return this.jasenID;
    }
    
    /**
     * @param id idksi asetettava arvo
     */
    public void setJasenID(int id) {
        this.jasenID = id;
    }

    



    
    /**
     * määrittää jäsenelle ID:n ja alustaa seuraavan jäsenen tulevaksi id:ksi yhden suuremman.
     * @return luodun jasenen ID:n
     */
    public int rekisteroi() {
        jasenID = seuraavajasenID;
        seuraavajasenID ++;
        return jasenID;
    }
    
    /**
     * Tulostetaan henkilön tiedot
     * @param out tietovirta johon tulostetaan
     */

    public void tulosta(PrintStream out) {
        out.println(String.format("%03d", jasenID, 3) + " " + nimi + " " + syntymavuosi);
        //TODO: lisää alle asuinpaikain tulostaminen asuinpaikka ID:n avulla.

    }
    
    /**
     * Tulostetaan henkilön tiedot
     * @param os tietovirta johon tulostetaan
     */
    public void tulosta(OutputStream os) {
        tulosta(new PrintStream(os));
    }


    
    
    /**
     * @param args ei käytössä
     */
    public static void main(String args[]) {
        Jasen aku = new Jasen(), aku2 = new Jasen();
        aku.rekisteroi();
        aku2.rekisteroi();
        aku.tulosta(System.out);
        aku.vastaaAkuAnkka();
        aku.tulosta(System.out);

        aku2.vastaaAkuAnkka();
        aku2.tulosta(System.out);

        aku2.vastaaAkuAnkka();
        aku2.tulosta(System.out);
    }


}
