package LenkkiVihko;

import java.util.Arrays;

/**
 * @author Ossian
 * @version 13.3.2025
 *
 */
public class Jasenet {
    
    private Jasen[] jasenet = new Jasen[10];
    private int jasenia = 0;

    
    /**
     * konstruktori
     */
    public Jasenet() {
        
    }
    

    /**
     * @return olemassa olevat jasenet
     */
    public Jasen[] getJasenet() {
        return jasenet;    
    }
    
    /**
     * @return palautaa jäsenten lukumäärän
     */
    public int getLkm() {
        return jasenia;
    }
    

    /**
     * tämä metodi lisää jäsenen, joka saa parametreinä vastaanotetut tiedot.
     * @param nimi luotavan jäsenen nimi
     * @param sv syntymävuosi
     * @param apID asuinpaikkaID
     * @throws SailoException heitetään, jos jäseniä ei mahdu enempää
     */
    public void lisaa(String nimi, int sv, int apID) throws SailoException {
        if (jasenet.length == jasenia) jasenet = Arrays.copyOf(jasenet, jasenet.length + 10);
        if (jasenet.length == jasenia) throw new SailoException("ei mahdu lisää jäseniä");
        
        Jasen jasen = new Jasen(nimi, sv, apID); // tässä luodaan uusi jäsen, joka luo uuden id:n
        
        int i = onkoOlemassa(nimi);     // tutkitaan onko tämän niminen jäsen olemassa
        if (i >= 0) {
            int id = jasenet[i].getJasenID();
            jasenet[i] = jasen;         // tässä korvataan olemassa oleva jäsen, koska annettu nimi oli olemassa
            jasenet[i].setJasenID(id);
            jasen.seuraavajasenID --; // tässä seuraavan jäsenen id palautetaan ennalleen, koska jäsen korvasi olemassaolevan
        } else {
            jasenet[jasenia] = jasen; // tässä elsen sisällä luodaan kokonaan uusi jäsen
            jasenia ++;
        }

    }
     /**
      * TODO: tähän tässä ja muissa metodeissa metodin toimintaa
      * @param jasen jasen, jonka nimen olemassaoloa tutkitaan
      *
      */
    private int onkoOlemassa(String nimi) {
        for(int i = 0; i < jasenia; i++) {
            if (nimi.equals(jasenet[i].getNimi())) return i;
        }
        return -1;
    }


    /**
     * @param i indeksi
     * @return palauttaa indeksissä olevan jäsenen
     */
    public Jasen anna(int i) {
        return jasenet[i]; 
    }
    
    
    /**
     * Tallentaa jäsenistön tiedostoon.  Kesken.
     * @throws SailoException jos talletus epäonnistuu
     */
    public void talleta() throws SailoException {
        throw new SailoException("Ei osata vielä tallettaa tiedostoa ");
    }

    
    /**
     * @param args ei käytössä
     
    public static void main(String args[]) {
        Jasenet jasenet = new Jasenet();

        Jasen aku = new Jasen(), aku2 = new Jasen();
        aku.rekisteroi();    aku.vastaaAkuAnkka();
        aku2.rekisteroi();   aku2.vastaaAkuAnkka();

        try {
            jasenet.lisaa(aku);
            jasenet.lisaa(aku2);

            System.out.println("========== Jäsenet testi ==============");

            for (int i=0; i<jasenet.getLkm(); i++) {
                Jasen jasen = jasenet.anna(i);
                System.out.println("Jäsen nro: " + i);
                jasen.tulosta(System.out);
            }

        } catch ( SailoException ex ) {
            System.out.println(ex.getMessage());
        }
    }
    */


    @SuppressWarnings("unused")
    private void lisaa(Jasen aku) throws SailoException{
        if (jasenet.length == jasenia) jasenet = Arrays.copyOf(jasenet, jasenet.length + 10);
        if (jasenet.length == jasenia) throw new SailoException("ei mahdu lisää jäseniä");
        
    }
}
