package LenkkiVihko;

import java.util.ArrayList;
import fi.jyu.mit.ohj2.*;

/**
 * @author Ossian
 * @version 13.3.2025
 *
 */
public class Lenkkivihko {
    private Jasenet jasenet = new Jasenet();
    private Asuinpaikat asuinpaikat = new Asuinpaikat();
    private Lenkit lenkit = new Lenkit();
    
    /**
     * lisätään uusi jäsen järjestelmään. 
     * @param tiedot lisätäävän jäsenen tarvittavat tiedot merkkijonona muodossa "nimi|2000|Lahti"
     * @example
     * <pre name="test">
     * 
     * </pre>
     */
    public void lisaaJasen(String tiedot) { // tiedot tulee parametrinä
        StringBuffer tiedotSb = new StringBuffer(tiedot);
        String nimi = Mjonot.erota(tiedotSb, '|');
        int sv = Mjonot.erota(tiedotSb, '|', -1);
        String ap = Mjonot.erota(tiedotSb, '|');
        
        int apID = asuinpaikat.getApID(ap);     // haetaan asuinpaikalle id nimen perusteella
        if (apID == -1) apID = asuinpaikat.luoAsuinpaikka(ap);
        
        
        try {
            jasenet.lisaa(nimi, sv, apID); 
            
        } catch ( SailoException ex ) {
            System.out.println(ex.getMessage());
        }

    }
    
    /**
     * @return olemassa olevat jasenet
     */
    public Jasen[] getJasenet() {
        return jasenet.getJasenet();    
    }
    
    /**
     * @return jäsenten lukumäärän
     */
    public int getJsnLkm() {
        return jasenet.getLkm();
    }
    
    /**
     * @param jasenID jäsenen, jonka lenkkien määrä palautetaan, id
     * @return palauttaa lenkkien lukumäärän.
     */
    public int getLenkkienLkm(int jasenID) {
        return lenkit.getLkm(jasenID);
    }
    
    /**
     * @param jasenID halutun jäsenen id
     * @return lenkit
     */
    public ArrayList<Lenkki> getLenkit(int jasenID) {
        return lenkit.getLenkit(jasenID);
        
    }
    
    /**
     * @param apID asuinpaikan id
     * @return asuinpaikan nimi
     */
    public String getAsuinpaikka(int apID) {
        return asuinpaikat.getAsuinpaikka(apID);
    }
    
    /**
     * lisää lenkin järjestelmään
     * @param lenkki lisättävä lenkki
     */
    public void lisaaLenkki(Lenkki lenkki) { // tiedot tulee parametreinä
        
        lenkit.lisaa(lenkki);
    }
    
        
    
    
}
