package fxLenkkiVihko;


import java.net.URL;
import java.util.ArrayList;
import java.util.ResourceBundle;

import LenkkiVihko.Jasen;
import LenkkiVihko.Lenkki;
import LenkkiVihko.Lenkkivihko;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;

/**
 * @author ossia
 * @version 22.1.2025
 * Tässä controlleri LenkkiVihkon pääikkunalle
 */
public class LenkkiVihkoGUIController  implements Initializable{
    
    @FXML
    private ListChooser<Jasen> jasenLista;
    @FXML
    private ListChooser<Lenkki> lenkkiLista;
    @FXML
    private TextField nimiKentta;
    @FXML
    private TextField ikaKentta;
    @FXML
    private TextField apKentta;
    
    private Lenkkivihko lenkkivihko;
    

    @FXML
    void apua(ActionEvent event) {
        Dialogs.showMessageDialog("Ei osata auttaa vielä");
    }

    /**
     * 
     * @param event tapahtuma
     * Kun halutaan hallita jäseniä, avataan siihen tarkoitettu ikkuna.
     */
    @FXML
    void jasenenHallinta(ActionEvent event) {
     // ikkunassa ei ole vielä toimintoja
        String jasenenTiedot = jasenenHallintaGUIController.kysyTiedot();
        lenkkivihko.lisaaJasen(jasenenTiedot);
        Jasen[] jasenet = lenkkivihko.getJasenet();
        alusta(jasenet);
    }

    
    private void alusta() {
        jasenLista.clear();
        lenkkiLista.clear();
    }


    private void alusta(Jasen[] jasenet) {
        jasenLista.clear();
        for (int i = 0; i < lenkkivihko.getJsnLkm(); i++) {
            jasenLista.add(jasenet[i].getNimi(), jasenet[i]);
        }
        

    }

    /**
     * 
     * @param event tapahtuma
     * Kutsuttaessa avataan suoritteen lisäämiseen tarkoitettu ikkuna.
     */
    @FXML
    void lisaaSuorite(ActionEvent event) {
        int jasenID = jasenLista.getSelectedObject().getJasenID();
        Lenkki lenkki = UusiSuoriteGUIController.kysyTiedot();
        lenkki.setJasenID(jasenID);
        lenkkivihko.lisaaLenkki(lenkki);
        ArrayList<Lenkki> lenkit = lenkkivihko.getLenkit(jasenID);
        alusta(lenkit);
        
    }
    
    private void alusta(ArrayList<Lenkki> lenkit) {
        lenkkiLista.clear();
        for (int i = 0; i < lenkit.size(); i++) {
            lenkkiLista.add(lenkit.get(i).getLenkinS(), lenkit.get(i));
        }
    }
    
    @FXML
    void naytaJasen(MouseEvent event) {
        lenkkiLista.clear();
        Jasen valittujasen = jasenLista.getSelectedObject();
        int jasenID = valittujasen.getJasenID();
        ArrayList <Lenkki> lenkit = new ArrayList<>();
        lenkit = lenkkivihko.getLenkit(jasenID);
        for (int i = 0; i < lenkkivihko.getLenkkienLkm(jasenID); i++) {
            lenkkiLista.add(lenkit.get(i).getPvm() + " " + lenkit.get(i).getMatka(), lenkit.get(i));
        }
        nimiKentta.setText(valittujasen.getNimi());
        ikaKentta.setText(String.valueOf(valittujasen.getSv()));
        apKentta.setText(lenkkivihko.getAsuinpaikka(valittujasen.getApID()));
        
        
    }
    
    
    @FXML
    void lopetus(ActionEvent event) {
        Dialogs.showMessageDialog("Ei osata lopettaa vielä");
    }

    @FXML
    void poistaJasen(ActionEvent event) {
        //TODO: en osannu tehdä uutta fxml tiedostoa tälle toiminnolle.
        Dialogs.showMessageDialog("Ei osata poistaa vielä ");
    }

    @FXML
    void tallennus(ActionEvent event) {
        Dialogs.showMessageDialog("Ei osata tallentaa vielä ");
    }

    @FXML
    void tietoja(ActionEvent event) {
        Dialogs.showMessageDialog("Ei osata näyttää tietoja vielä ");
    }

    /**
     * @param lenkkivihko ..
     */
    public void setLenkkivihko(Lenkkivihko lenkkivihko) {
        this.lenkkivihko = lenkkivihko;
        
    }

    @Override
    public void initialize(URL arg0, ResourceBundle arg1) {
        alusta();
        
    }
    
}